Listing 1 - Load method of the form
STORE CREATEOBJECT("Scripting.FileSystemObject") ;
  TO ThisForm.fso

*-- How many drives do we have?
STORE ThisForm.fso.Drives.Count TO m.lnNumDrives

*-- Create an array big enough to hold the drive 
*-- details for the list box
DECLARE ThisForm.aDrives[lnNumDrives, 2]

STORE 1 TO ln

*-- Get the details of each drive from the Drives 
*-- collection and put them into the array
WITH ThisForm
  FOR EACH ldrv in .fso.Drives

    STORE ldrv.DriveLetter TO .aDrives[ln,1]

*-- We would get a failure if we ask for the volume
*-- name of a drive that isn't ready
    IF ldrv.IsReady = .T.
       STORE ldrv.VolumeName TO .adrives[ln,2]
    ELSE
       STORE "Not Ready" TO .aDrives[ln,2]
    ENDIF

    STORE ln + 1 TO ln

  NEXT ldrv

ENDWITH 

Listing 2	- InteractiveChange method of the listbox
#DEFINE IC_MEGABYTE 1048576  && Convert bytes to Mb

*-- Get the drive whose drive letter has been selected
WITH ThisForm
  STORE .fso.GetDrive(.lstDrives.Value) TO drvSelected
ENDWITH

WITH drvSelected
  STORE .DriveLetter TO ThisForm.txtDriveLetter.Value

*-- Do we recognise this type of disk?
  IF .DriveType >= 1 AND ;
     .DriveType <= 5
    STORE ThisForm.aTypes[.DriveType] TO ;
      ThisForm.txtDriveType.Value
  ELSE
    STORE "Unknown" TO ThisForm.txtDriveType.Value
  ENDIF

*-- These values are only available if disk is ready
  IF .IsReady = .T.
    STORE .VolumeName TO ThisForm.txtVolumeName.Value
    STORE .SerialNumber TO ;
      ThisForm.txtSerialNumber.Value
    STORE .FileSystem TO ThisForm.txtFileSystem.Value
    STORE INT(.FreeSpace / IC_MEGABYTE) TO ;
      ThisForm.txtFreeSpace.Value
    STORE INT(.TotalSize / IC_MEGABYTE) TO ;
      ThisForm.txtTotalSize.Value
  ELSE
    STORE "Not Ready" TO ThisForm.txtVolumeName.Value
    STORE "" TO ThisForm.txtSerialNumber.Value
    STORE "" TO ThisForm.txtFileSystem.Value
    STORE "" TO ThisForm.txtFreeSpace.Value 
    STORE "" TO ThisForm.txtTotalSize.Value
  ENDIF

ENDWITH
#UNDEFINE IC_MEGABYTE

Listing 3 - Recursively scanning for files
*-- Look at all the drives available and search for 
*-- files on the local hard disks.

FOR EACH drv IN fso.Drives
*-- Is this a local hard disk?
  IF drv.DriveType = 2
    Thisform.GetFiles(drv.RootFolder)
  ENDIF
NEXT drv


*--Method GetFiles
PARAMETER tfld

*-- Look at every file in this folder and add it to
*-- the list box if it's of type "DBF"
FOR EACH fil IN tfld.Files
  IF UPPER(fso.GetExtensionName(fil.Name)) = "DBF"
    ThisForm.lstFiles.AddItem(fil.Path)
  ENDIF 
NEXT fil

*-- Now repeat the operation for all the subfolders of 
*-- this folder
FOR EACH fldSub IN tfld.SubFolders
  Thisform.Getfiles(fldSub)
NEXT fldSub 

