**********************************************************************
* Program....: DatToTxt.prg
* Compiler...: Visual FoxPro 06.00.8492.00 for Windows
* Abstract...: Create a text file containing the data from the table
**********************************************************************
LPARAMETERS tcTable, tcOutFile
LOCAL lcTable, lnFields, lnCnt, lcOutStr

*** Ignore parameter checking for the purpose of this file
lcTable = UPPER( ALLTRIM( tcTable ) )
IF ! USED( lcTable )
    USE ( lcTable ) IN 0 AGAIN SHARED NOUPDATE
ENDIF
SELECT ( lcTable )

*** Get the Field Count
lnFields = FCOUNT( lcTable )

*** Now we need to work through the table
SCAN

    *** Initialise the output string
    lcOutStr = ""

    *** Work through the fields
    FOR lnCnt = 1 TO lnFields
        *** Get the field name
        lcField = FIELD( lnCnt)
        *** Add a separator if the string is not empty
        lcOutStr = lcOutStr + IIF( ! EMPTY( lcOutStr ), ",", "" )
        *** Now add the field content as text
        lcOutStr = lcOutStr + DataToString( lcField )
    NEXT
	
	*** Write the string out to the output file
	*** But add the CRLF first
	lcOutStr = lcOutStr + CHR(13) + CHR(10)
	STRTOFILE( lcOutStr, tcOutFile, .T. )
	
ENDSCAN

*** And exit nicely
RETURN

********************************************************************
*** Convert a data value into a string suitable for inclusion in a 
*** Comma-Separated Value text file.
********************************************************************
FUNCTION DataToString( tcField )
LOCAL luFVal, lcType, lcRetVal

*** Get the field content
luFVal = &tcField

*** And its Type
lcType = VARTYPE( luFVal)

*** Ensure reurn value is a string
lcRetVal = ""

*** Convert from type to char
DO CASE
  CASE INLIST( lcType, 'I', 'N' ) AND INT( luFVal ) = luFVal      && Integer
    lcRetVal = ALLTRIM( STR( luFVal, 16, 0 ) )
  CASE INLIST( lcType, 'N', 'Y' )                   && Numeric or Currency
    lcRetVal = ALLTRIM( PADL( luFVal, 32 ) )
  CASE lcType = 'C'                                 && Character
    lcRetVal = '"' + ALLTRIM( luFVal ) + '"'
  CASE lcType = 'L'                                 && Logical
    lcRetVal = IIF( !EMPTY( luFVal ), 'T', 'F')
  CASE lcType = 'D'                                 && Date 
    lcRetVal = ALLTRIM( DTOC( luFVal ) )
  CASE lcType = 'T'                                 && DateTime 
    lcRetVal = ALLTRIM( TTOC( luFVal ) )
  OTHERWISE
    *** There is no otherwise unless, of course, Visual FoxPro adds
    *** a new data type. In this case, the function must be modified 
ENDCASE
*** Return value as character
RETURN lcRetVal
