**********************************************************************
* Program....: CompDir.prg
* Compiler...: Visual FoxPro 06.00.8492.00 for Windows
* Abstract...: Compare structures of all tables in two directories
* ...........: POoduce listing of differences
**********************************************************************
LPARAMETERS tcDir1, tcDir2
LOCAL ARRAY laSce[1], laTgt[1]
LOCAL llOk, lcSceDir, lcTgtDir, lcWasDir, lnSce, lnTgt, lnCnt, lcTgtFile, llIsSame

*** Set 'Success' flag
llOk = .T.
*** Did we get two directories
IF VARTYPE( tcDir1 ) # "C" OR EMPTY( tcDir1 )
    lcSceDir = GETDIR( CURDIR(), "Select Reference Dir" )
ELSE
    lcSceDir = ADDBS( ALLTRIM( tcDir1 ) )
ENDIF
IF VARTYPE( tcDir2 ) # "C" OR EMPTY( tcDir2 )
    lcTgtDir = GETDIR( CURDIR(), "Select Compare Dir" )
ELSE
    lcTgtDir = ADDBS( ALLTRIM( tcDir2 ) )
ENDIF

*** Save current location
lcWasDir  = FULLPATH( curdir() )

*** Get list of tables in Reference Directory
SET DEFAULT TO (lcSceDir)
lnSce = ADIR( laSce, '*.dbf' )

*** Restore Default work area
SET DEFAULT TO ( lcWasDir )

IF lnSce = 0
	*** Nothing to compare TO
	MESAGEBOX( "Source Directory does not contain any tables", 16, "Nothing to do!" )
	RETURN .F.
ENDIF

*** Create the results Cursor
CREATE CURSOR compstru ( ;
	RefFile  C( 40,0) NOT NULL, ;
	Result   C( 30,0) NOT NULL, ;
	CmpFile  C( 40,0))

*** Loop through the source array
FOR lnCnt = 1 TO lnSce
    lcTgtFile = lcTgtDir + ALLTRIM( laSce[lncnt,1] )
    lcSceFile = lcSceDir + ALLTRIM( laSce[lncnt,1] )
    IF FILE( lcTgtFile )
        *** Compare the structures
        llIsSame = CompStru( lcSceFile, lcTgtFile )
        IF ! llIsSame
            *** Target File is Different
			INSERT INTO compstru ( RefFile, CmpFile, Result ) ;
				VALUES ( lcSceFile, lcTgtFile, "Structures are not the same" )
        ENDIF
        *** Set Return Status to .F. if there are differences
        llOk = llOk AND llIsSame
    ELSE
    	*** Target Directory does not contain this file
		INSERT INTO compstru ( RefFile, CmpFile, Result ) ;
				VALUES ( lcSceFile, lcTgtFile, "No corresponding file found" )
		llOk = .F.
    ENDIF
NEXT	

*** Return .T. only if the two directories are identical in all respects
IF ! llOk
	SELECT compstru
	BROWSE NOWAIT
ENDIF
RETURN llOk

