* Program....: PICKLIST.PRG
* Abstract...: Populate PickHdr and PickDtl with initial
*               values for roll-out of application.
*
AddressType()
Gender()
Sex()

RETURN


*-------------------------------
PROCEDURE AddressType
	DO AddPick WITH "H", "AddressType", "Broad categories", , , "B"
	DO AddPick WITH "D", "School",      "School",                    "S", , , , , "AddressType"
	DO AddPick WITH "D", "Post-School", "Post-School",               "P", , , , , "AddressType"
	DO AddPick WITH "D", "LEA",         "Local Education Authority", "L", , , , , "AddressType"
	DO AddPick WITH "D", "Customer",    "Customer",                  "C", , , , , "AddressType"
	DO AddPick WITH "D", "Other",       "Other",                     "O", , , , , "AddressType"
ENDPROC


PROCEDURE Gender
	DO AddPick WITH "H", "Gender", "Main sex admitted", , , "B"
	DO AddPick WITH "D", "Girls", , "G", , , , , "Gender"
	DO AddPick WITH "D", "Boys",  , "B", , , , , "Gender"
	DO AddPick WITH "D", "Mixed", , "M", , , , , "Gender"
ENDPROC


PROCEDURE Sex
	DO AddPick WITH "H", "Sex", "Sex of person"
	DO AddPick WITH "D", "F", "Female", "F", , , , , "Sex"
	DO AddPick WITH "D", "M", "Male",   "M", , , , , "Sex"
ENDPROC

************************

PROCEDURE AddPick( tcTable, tcName, tcDesc, tcSValue, tcLValue, tcType, tcSQL, tcAction , tcList, tnOrder)

	tcTable  = IIF( TYPE( "tcTable" ) = "C" AND UPPER( LEFT( tcTable, 1 )) $ "HD", UPPER( LEFT( tcTable, 1 )), "" )
	tcName   = IIF( TYPE( "tcName" ) = "C", ALLTRIM( tcName ), "" )
	tcDesc   = IIF( TYPE( "tcDesc" ) = "C", ALLTRIM( tcDesc ), tcName )
	tcSValue = IIF( TYPE( "tcSValue" ) = "C", ALLTRIM( tcSValue ), "" )
	tcLValue = IIF( TYPE( "tcLValue" ) = "C", ALLTRIM( tcLValue ), tcSValue )
	tcType   = IIF( TYPE( "tcType " ) = "C" AND !EMPTY( tcType  ), ALLTRIM( tcType ), "B" )
	tcSQL    = IIF( TYPE( "tcSQL" ) = "C", ALLTRIM( tcSQL ), "" )
	tcAction = IIF( TYPE( "tcAction" ) != "C" OR !( tcAction $ "ACD" ), "A", tcAction )
	tcList   = IIF( TYPE( "tcList" ) = "C", ALLTRIM( tcList ), "" )
	tnOrder  = IIF( TYPE( "tnOrder" ) = "N", tnOrder , 0 )

	LOCAL llFoundHdr, llFoundDtl, lnHdrId, lnDtlId, lnCnt, lcDttm, lnCodeLen
	llFoundHdr   = .F.
	llFoundDtl   = .F.
	lnHdrId      = 0
	lnDtlId      = 0
	lnCodeLen    = 0

	IF !USED("PickHdr")
		USE ( "PickHdr" ) IN 0
	ENDIF
	IF !USED("PickDtl")
		USE ( "PickDtl" ) IN 0
	ENDIF

	IF !EMPTY( tcName )

		SELECT PickHdr
		LOCATE FOR UPPER( PkH_Name ) == UPPER( tcName )
		llFoundHdr = FOUND()

		IF tcTable = "H"
		SELECT PickHdr
		LOCATE FOR UPPER( PkH_Name ) == UPPER( tcName )
		llFoundHdr = FOUND()
			IF llFoundHdr
				lnHdrId = PKH_ID

				DO CASE
					CASE tcAction == "C" ;
					  OR tcAction == "A"
						REPLACE PkH_Name  WITH tcName ;
							   ,PkH_Desc  WITH tcDesc ;
							   ,PkH_Value WITH tcSValue ;
							   ,PkH_Type  WITH tcType ;
							   ,PkH_SQL   WITH tcSQL
					CASE tcAction == "D"
						REPLACE PkH_InUse WITH .F.
				ENDCASE

			ELSE
* create header
				lnHdrId  = GetNextID ( "PickHdr" )
				INSERT INTO PickHdr ;
						  ( PkH_ID, PkH_Name, PkH_Desc, PkH_Value, PkH_InUse, PkH_Type, PkH_SQL  ) ;
					VALUES( lnHdrId, tcName, tcDesc, tcSValue, .T., tcType, tcSQL )
				llFoundHdr = .T.
				IF tcAction == "D"
					REPLACE PkH_InUse WITH .F.
				ENDIF
			ENDIF
		ENDIF


		IF tcTable = "D"
			SELECT PickHdr
			LOCATE FOR UPPER( PkH_Name ) == UPPER( tcList )

			IF FOUND()
				lnHdrId = PKH_ID

				lnCodeLen  = LEN( tcSValue )
				IF lnCodeLen > PkH_DtlSLen
					REPLACE PkH_DtlSLen WITH lnCodeLen
				ENDIF
				lnCodeLen  = LEN( tcLValue )
				IF lnCodeLen > PkH_DtlLLen
					REPLACE PkH_DtlLLen WITH lnCodeLen
				ENDIF

				SELECT PickDtl
				LOCATE FOR PkD_PkHFK = lnHdrId ;
				       AND UPPER( PkD_Name ) == UPPER( tcName )
				llFoundDtl = FOUND()

				IF llFoundDtl
				* Detail exists
					DO CASE
						CASE tcAction == "C" ;
						  OR tcAction == "A"
							REPLACE PkD_Name   WITH tcName ;
							       ,PkD_Desc   WITH tcDesc ;
							       ,PkD_SValue WITH tcSValue ;
								   ,PkD_LValue WITH tcLValue ;
								   ,PkD_SQL    WITH tcSQL ;
								   ,PkD_Order  WITH tnOrder ;
								   ,PkD_InUse  WITH .T.
						CASE tcAction == "D"
							REPLACE PkD_InUse WITH .F.
					ENDCASE
				ELSE
				* create detail, whether it's a N,C,V or D
					lnDtlId  = GetNextID( "PickDtl" )

					INSERT INTO PickDtl;
							  ( PkD_ID, PkD_PkHFK, PkD_Name, PkD_Desc, PkD_SValue, PkD_LValue, PkD_InUse, PkD_SQL, PkD_Order) ;
						VALUES( lnDtlId, lnHdrId, tcName, tcDesc, tcSValue, tcLValue, .T., tcSQL, tnOrder)
					IF tcAction = "D"
						REPLACE PkD_InUse WITH .F.
					ENDIF
				ENDIF
			ENDIF
		ENDIF
	ENDIF
	RETURN
ENDPROC
